import { Injectable, ɵɵdefineInjectable, Component, NgModule } from '@angular/core';
import { firestore } from 'firebase/app';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/service/ngx-timestamp-date.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgxTimestampDateService = /** @class */ (function () {
    function NgxTimestampDateService() {
    }
    /**
     * @param {?} timestamp
     * @return {?}
     */
    NgxTimestampDateService.prototype.timestampToDate = /**
     * @param {?} timestamp
     * @return {?}
     */
    function (timestamp) {
        /** @type {?} */
        var date = (/** @type {?} */ (timestamp));
        return date.toDate();
    };
    /**
     * @param {?} date
     * @return {?}
     */
    NgxTimestampDateService.prototype.dateToTimestamp = /**
     * @param {?} date
     * @return {?}
     */
    function (date) {
        return firestore.Timestamp.fromDate(date);
    };
    /**
     * @template T
     * @param {?} data
     * @return {?}
     */
    NgxTimestampDateService.prototype.parseTimestampToDate = /**
     * @template T
     * @param {?} data
     * @return {?}
     */
    function (data) {
        var _this = this;
        /** @type {?} */
        var doc = data;
        if (doc) {
            if (Array.isArray(doc)) {
                doc = doc.map(this.checkPropertyValue.bind(this));
            }
            if (doc.constructor.name === 'Object') {
                Object.keys(doc).forEach((/**
                 * @param {?} key
                 * @return {?}
                 */
                function (key) {
                    doc[key] = _this.checkPropertyValue(doc[key]);
                }));
            }
        }
        return doc;
    };
    /**
     * @private
     * @param {?} element
     * @return {?}
     */
    NgxTimestampDateService.prototype.checkPropertyValue = /**
     * @private
     * @param {?} element
     * @return {?}
     */
    function (element) {
        if (element) {
            if ((element._seconds >= 0 || element.seconds >= 0) &&
                (element._nanoseconds >= 0 || element.nanoseconds >= 0)) {
                element = new Date((element._seconds || element.seconds) * 1000);
            }
            else {
                element = this.parseTimestampToDate(element);
            }
        }
        return element;
    };
    NgxTimestampDateService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    NgxTimestampDateService.ctorParameters = function () { return []; };
    /** @nocollapse */ NgxTimestampDateService.ngInjectableDef = ɵɵdefineInjectable({ factory: function NgxTimestampDateService_Factory() { return new NgxTimestampDateService(); }, token: NgxTimestampDateService, providedIn: "root" });
    return NgxTimestampDateService;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: lib/components/ngx-timestamp-date.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgxTimestampDateComponent = /** @class */ (function () {
    function NgxTimestampDateComponent() {
    }
    /**
     * @return {?}
     */
    NgxTimestampDateComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
    };
    NgxTimestampDateComponent.decorators = [
        { type: Component, args: [{
                    selector: 'lib-ngx-timestamp-date',
                    template: "\n    <p>\n      ngx-timestamp-date works!\n    </p>\n  "
                }] }
    ];
    /** @nocollapse */
    NgxTimestampDateComponent.ctorParameters = function () { return []; };
    return NgxTimestampDateComponent;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ngx-timestamp-date.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgxTimestampDateModule = /** @class */ (function () {
    function NgxTimestampDateModule() {
    }
    NgxTimestampDateModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [
                        NgxTimestampDateComponent
                    ],
                    imports: [],
                    exports: [
                        NgxTimestampDateComponent
                    ],
                    providers: [
                        NgxTimestampDateService
                    ]
                },] }
    ];
    return NgxTimestampDateModule;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: ngx-timestamp-date.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NgxTimestampDateComponent, NgxTimestampDateModule, NgxTimestampDateService };
//# sourceMappingURL=ngx-timestamp-date.js.map
